/********************************************************************
	created:	2001/06/15
	created:	15:6:2001   21:17
	filename: 	cpphelpers.h
	file base:	cpphelpers
	file ext:	h
	author:		Alex Alexandrov
	
	purpose:	Some useful stuff that I have to include into every program
*********************************************************************/

#define r_cst reinterpret_cast
#define s_cst static_cast
#define d_cst dynamic_cast
#define c_cst const_cast


#include <malloc.h>
#include <TChar.h>

// Macros for working with resources
#define _AA_MAX_RESOURCE_STRING 256
inline PTSTR _AA_Load_String(PTSTR p_ptstrStr, HMODULE p_hmodRes, UINT p_uiResID) 
{
	::LoadString(p_hmodRes, p_uiResID, p_ptstrStr, _AA_MAX_RESOURCE_STRING - 1);
	return p_ptstrStr;
}
#define USES_RESSTR


#ifdef _ATL
#define _AA_GET_RES_HMODULE _Module.GetResourceInstance()
#else
#define _AA_GET_RES_HMODULE GetModuleHandle(NULL)
#endif //_ATL

#define RESSTR(id) _AA_Load_String((PTSTR)_alloca(_AA_MAX_RESOURCE_STRING *\
sizeof(TCHAR)), _AA_GET_RES_HMODULE, id)

#include <string>
typedef std::basic_string<TCHAR> tstring; 
