// BackColorWindow.h: interface for the CBackColorWindow class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BACKCOLORWINDOW_H__C20935EE_1BE0_425C_8FC3_A31B3948A849__INCLUDED_)
#define AFX_BACKCOLORWINDOW_H__C20935EE_1BE0_425C_8FC3_A31B3948A849__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Resource.h"
#include "PropertyWindow.h"
#include "CommonDefs.h"

#define INITIAL_BACKCOLOR_R		0.0f
#define INITIAL_BACKCOLOR_G		0.0f
#define INITIAL_BACKCOLOR_B		0.0f

class CBackColorWindow: public CPropertyWindow<CBackColorWindow>
{

public:
	enum { IDD = IDD_BACKGROUNDCOLOR };

/////////////////////////////////////////////////////////////////////////////////////////
// CBackColorWindow construction/destruction
//
public:

/////////////////////////////////////////////////////////////////////////////////////////
// CBackColorWindow member variables
//
private:

protected:	

public:
/////////////////////////////////////////////////////////////////////////////////////////
// CBackColorWindow methods 
//
private:
	
protected:
	BOOL InitSliders();
	BOOL UpdateInfo();

public:
	HRESULT GetBackColor(
		PFLOAT p_pflBackColorR, 
		PFLOAT p_pflBackColorG,
		PFLOAT p_pflBackColorB);

/////////////////////////////////////////////////////////////////////////////////////////
// CBackColorWindow message map and message handlers 
//

	BEGIN_MSG_MAP(CBackColorWindow)
		CHAIN_MSG_MAP(CPropertyWindow<CBackColorWindow>)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_HSCROLL, OnScrolling)
		MESSAGE_HANDLER(WM_VSCROLL, OnScrolling)
	END_MSG_MAP()


	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, 
		LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		InitSliders();
		return TRUE;
	}

	LRESULT OnScrolling(UINT p_uMsg, WPARAM p_wParam, LPARAM p_lParam, BOOL& p_bHandled)
	{
		HRESULT hr;hr;
		if (m_pNotifee) {
			m_pNotifee->ParametersChanged(IDD);
		}
		UpdateInfo();
		return 0;
	}

};

#endif // !defined(AFX_BACKCOLORWINDOW_H__C20935EE_1BE0_425C_8FC3_A31B3948A849__INCLUDED_)
