// D3DSample.cpp : main source file for D3DSample.exe
//

#include "stdafx.h"

#include "resource.h"

#include "maindlg.h"

CComModule _Module;


int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes = ::CoInitialize(NULL);
// If you are running on NT 4.0 or higher you can use the following call instead to 
// make the EXE free threaded. This means that calls come in on a random RPC thread.
//	HRESULT hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	ATLASSERT(SUCCEEDED(hRes));

#if (_WIN32_IE >= 0x0300)
	INITCOMMONCONTROLSEX iccx;
	iccx.dwSize = sizeof(iccx);
	iccx.dwICC = ICC_COOL_CLASSES | ICC_BAR_CLASSES;
	BOOL bRet = ::InitCommonControlsEx(&iccx);
	bRet;
	ATLASSERT(bRet);
#else
	::InitCommonControls();
#endif

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));


	CMainDlg dlgMain;
	dlgMain.Create(NULL);
// Add errors checking
	
	dlgMain.ShowWindow(SW_SHOW);

	MSG theMsg;
	
	while(GetMessage(&theMsg, NULL, 0, 0)) {
		// Main message loop....
		
		if (!dlgMain.DispatchDialogMessage(&theMsg)) {
			TranslateMessage(&theMsg);	
			DispatchMessage(&theMsg);
		}
	}

	_Module.Term();
	::CoUninitialize();

	return 0;
}
