// FunctionTypeWindow.cpp: implementation of the CFunctionTypeWindow class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "FunctionTypeWindow.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

INT CFunctionTypeWindow::UpdateCurrentFunctionID()
{
	
	if (BST_CHECKED == IsDlgButtonChecked(IDC_RB_FUNCTIONTYPE_SINX)) {
		return (m_nCurrentFunctionID = IDC_RB_FUNCTIONTYPE_SINX);
	}
	
	if (BST_CHECKED == IsDlgButtonChecked(IDC_RB_FUNCTIONTYPE_PLANE)) {
		return (m_nCurrentFunctionID = IDC_RB_FUNCTIONTYPE_PLANE);
	}

	if (BST_CHECKED == IsDlgButtonChecked(IDC_RB_FUNCTIONTYPE_PARABOLOID)) {
		return (m_nCurrentFunctionID = IDC_RB_FUNCTIONTYPE_PARABOLOID);
	}
		
	return (m_nCurrentFunctionID = -1);
}

BOOL CFunctionTypeWindow::UpdateState()
{
	UpdateCurrentFunctionID();
	if (0 >= m_nCurrentFunctionID) {
		return FALSE;
	}
	
	if (m_pNotifee) {
		m_pNotifee->ParametersChanged(IDD);
	}
	return TRUE;
}
