// FunctionTypeWindow.h: interface for the CFunctionTypeWindow class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FUNCTIONTYPEWINDOW_H__8AD69E8D_453A_456F_A175_7FAB9A2EFF4F__INCLUDED_)
#define AFX_FUNCTIONTYPEWINDOW_H__8AD69E8D_453A_456F_A175_7FAB9A2EFF4F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Resource.h"
#include "PropertyWindow.h"
#include "CommonDefs.h"

class CFunctionTypeWindow: public CPropertyWindow<CFunctionTypeWindow>
{

public:
	enum { IDD = IDD_FUNCTIONTYPE };

/////////////////////////////////////////////////////////////////////////////////////////
// CFunctionTypeWindow construction/destruction
//
public:

/////////////////////////////////////////////////////////////////////////////////////////
// CFunctionTypeWindow member variables
//
private:

protected:	
	INT m_nCurrentFunctionID;
public:
/////////////////////////////////////////////////////////////////////////////////////////
// CFunctionTypeWindow methods 
//
private:
	
protected:
	INT UpdateCurrentFunctionID();
	BOOL UpdateState();
public:
	INT GetCurrentFunctionID() {return m_nCurrentFunctionID;}
/////////////////////////////////////////////////////////////////////////////////////////
// CFunctionTypeWindow message map and message handlers 
//

	BEGIN_MSG_MAP(CFunctionTypeWindow)
		CHAIN_MSG_MAP(CPropertyWindow<CFunctionTypeWindow>)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_HANDLER(IDC_RB_FUNCTIONTYPE_SINX, BN_CLICKED, 
			OnFunctionChange)
		COMMAND_HANDLER(IDC_RB_FUNCTIONTYPE_PLANE, BN_CLICKED, 
			OnFunctionChange)
		COMMAND_HANDLER(IDC_RB_FUNCTIONTYPE_PARABOLOID, BN_CLICKED, 
			OnFunctionChange)
	END_MSG_MAP()


	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, 
		LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		INT m_nCurrentFunctionID = -1;
		
		CheckRadioButton(IDC_RB_FUNCTIONTYPE_SINX, 
			IDC_RB_FUNCTIONTYPE_PARABOLOID,
			IDC_RB_FUNCTIONTYPE_SINX);
		UpdateState();
		return TRUE;
	}

	LRESULT OnFunctionChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		UpdateState();
		return 0;
	}
};

#endif // !defined(AFX_FUNCTIONTYPEWINDOW_H__8AD69E8D_453A_456F_A175_7FAB9A2EFF4F__INCLUDED_)
